/***********

This software module was originally developed by

Samsung Advanced Institute of Technology

and edited by
JungHoe Kim (Samsung Advanced Institute of Technology)

in the course of development of the MPEG-4 extension 5 
audio scalable lossless (SLS) coding . This software module is an 
implementation of a part of one or more MPEG-4 Audio tools as 
specified by the MPEG-4 Audio standard. ISO/IEC  gives users of the
MPEG-4 Audio standards free license to this software module
or modifications thereof for use in hardware or software products
claiming conformance to the MPEG-4 Audio  standards. Those
intending to use this software module in hardware or software products
are advised that this use may infringe existing patents. The original
developer of this software module, the subsequent
editors and their companies, and ISO/IEC have no liability for use of
this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-4
Audio conforming products. The original developer retains full right to
use the code for the developer's own purpose, assign or donate the code to a
third party and to inhibit third party from using the code for non
MPEG-4 Audio conforming products. This copyright notice
must be included in all copies or derivative works. 

Copyright 2005.  

***********/
/******************************************************************** 
/
/ filename : BstTruncation.c
/ project : MPEG-4 audio scalable lossless coding
/ author : JungHoe Kim, Samsung Advanced Institute of Technology <kjh94@samsung.com>
/ date : June., 2005
/ contents/description : Bitstream Truncator
/    

*/

#include <stdio.h>
#include <stdlib.h>

int
main(int argc, char *argv[])
{
	int t;
	int targetBitrate;
	int osf,sampling_rate;
	unsigned short frame_len;
	FILE *ptrIn;
	FILE *ptrOut;
	unsigned char *bstBuf;
	long tbits;

	if(argc !=6)
	{
		fprintf(stderr,"\nInvalid argument");
		fprintf(stderr,"\n[executable] input_file output_file target_bitrate osf sampling_rate");
		return 1;
	}
	// input_file output_file target_bitrate osf sampling_rate
	targetBitrate = atoi(argv[3]);
	osf = atoi(argv[4]);
	sampling_rate = atoi(argv[5]);

	ptrIn = fopen(argv[1],"rb");
	if(ptrIn==0)
	{
		fprintf(stderr,"\nNo input file");
		exit(1);
	}
	ptrOut = fopen(argv[2],"wb");
	if(ptrOut==0)
	{
		fprintf(stderr,"\nNo output file");
		exit(1);
	}
	//caculate available bits per channel
	tbits = (int)(targetBitrate/2.*1024.*osf/sampling_rate+0.5)-16;
	tbits = (tbits+7)/8;//in byte

	fread(&frame_len,1,1,ptrIn);//read PCM type
	fwrite(&frame_len,1,1,ptrOut);//read PCM type

	while(1)
	{
		if(fread(&frame_len,2,1,ptrIn)==0)
			break;
		bstBuf = (unsigned char*)malloc(frame_len);
		fread(bstBuf,1,frame_len,ptrIn);

		frame_len = frame_len < tbits ? frame_len:tbits;

		fwrite(&frame_len,2,1,ptrOut);
		fwrite(bstBuf,1,frame_len,ptrOut);
		free(bstBuf);
	}
	

	fclose(ptrIn);
	fclose(ptrOut);
}