/************************* MPEG-2 NBC Audio Decoder **************************
 *                                                                           *
"This software module was originally developed by 
AT&T, Dolby Laboratories, Fraunhofer Gesellschaft IIS and edited by
Yoshiaki Oikawa (Sony Corporaion),
Mitsuyuki Hatanaka (Sony Corporation),
in the course of development of the MPEG-2 NBC/MPEG-4 Audio standard ISO/IEC 13818-7, 
14496-1,2 and 3. This software module is an implementation of a part of one or more 
MPEG-2 NBC/MPEG-4 Audio tools as specified by the MPEG-2 NBC/MPEG-4 
Audio standard. ISO/IEC  gives users of the MPEG-2 NBC/MPEG-4 Audio 
standards free license to this software module or modifications thereof for use in 
hardware or software products claiming conformance to the MPEG-2 NBC/MPEG-4
Audio  standards. Those intending to use this software module in hardware or 
software products are advised that this use may infringe existing patents. 
The original developer of this software module and his/her company, the subsequent 
editors and their companies, and ISO/IEC have no liability for use of this software 
module or modifications thereof in an implementation. Copyright is not released for 
non MPEG-2 NBC/MPEG-4 Audio conforming products.The original developer
retains full right to use the code for his/her  own purpose, assign or donate the 
code to a third party and to inhibit third party from using the code for non 
MPEG-2 NBC/MPEG-4 Audio conforming products. This copyright notice must
be included in all copies or derivative works." 
Copyright(c)1996.
 *                                                                           *
 ****************************************************************************/

#ifndef	_port_h_
#define	_port_h_

#include "all.h"
#include "monopred.h"
#include "lit_ll_dec.h"


void		apply_drc(Float *coef, int ch);
int		byte_align(void);
void		byteclr(byte *ip1, int cnt);
int		ch_index(MC_Info *mip, int cpe, int tag);
void		check_mc_info(MC_Info *mip, int new_config);
int		chn_config(int id, int tag, int common_window, MC_Info *mip);
void		closefiles();
void		clr_tns( Info *info, TNS_frame_info *tns_frame_info );
int		decode_huff_cw(Huffman *h);
int		dynamic_range_info(void);
/*int		endblock(void); see 'nulltio.c' */
int		enter_chn(int cpe, int tag, char position, int common_window, MC_Info *mip);
int		enter_mc_info(MC_Info *mip, ProgConfig *pcp);
Float		esc_iquant(int q);
int		extension_payload(int cnt, byte *data);
long		f2ir(float x);
void		fltclr(Float *dp1, int cnt);
void		fltcpy(Float *dp1, Float *dp2, int cnt);
void		fltset(Float *dp1, Float dval, int cnt);
void		fmtchan(char *p, float *data, int stride);
int		get_adif_header(int extended_show);
void		get_adts_header(void);

void		get_ics_info(byte *win, 
			     byte *wshape, 
			     byte *group,
			     byte *max_sfb, 
			     int *lpflag, 
			     int *prstflag, 
			     NOK_LT_PRED_STATUS *nok_ltp_status, 
			     NOK_LT_PRED_STATUS *nok_ltp_status_right, 
			     int stereo_flag
			     );
int		get_prog_config(ProgConfig *p);
void		get_sign_bits(int *q, int n);
int		get_tns( Info *info, TNS_frame_info *tns_frame_info );
long		getbits(int n);

long	ll_getbits(int n, int ll_layer);
long ll_getshort(int ll_layer);
int		getdata(int *tag, int *dt_cnt, byte *data_bytes);
int		getescape(int q);
void		getfill(byte *data);
void		getgroup(Info *info, byte *group);

int		getics(Info *info, 
		       int common_window, 
		       byte *win, 
		       byte *wshape, 
		       byte *group, 
		       byte *max_sfb, 
		       int *lpflag, 
		       int *prstflag, 
		       byte *cb_map, 
		       Float *coef,
		       LIT_LL_quantInfo *ll_info,
		       short *global_gain, 
		       short *factors,
		       NOK_LT_PRED_STATUS *nok_ltp_status,
		       TNS_frame_info *tns    
		       );


int		getmask(Info *info, byte *group, byte max_sfb, byte *mask);
long		getshort(void);
void		huffbookinit(void);
int		huffcb(byte *sect, int *sectbits, int tot_sfb, int sfb_per_sbk, byte max_sfb);

int		huffdecode(int id, 
			   MC_Info *mip, 
			   byte *win, 
			   Wnd_Shape *wshape, 
			   byte **cb_map, 
			   short **factors,  
			   byte **group, 
			   byte *hasmask, 
			   byte **mask, 
			   byte *max_sfb, 
			   int **lpflag, 
			   int **prstflag,
			   NOK_LT_PRED_STATUS **nok_ltp,
			   TNS_frame_info **tns, 
			   Float **coef,
			   LIT_LL_quantInfo **ll_coef
			   );

int		hufffac(Info *info, 
			byte *group, 
			int nsect, 
			byte *sect,
			short global_gain, 
			short *factors,
			LIT_LL_quantInfo *ll_info
			);
int		huffspec(Info *info, 
			 int nsect, 
			 byte *sect, 
			 short *factors, 
			 Float *coef,
			 LIT_LL_quantInfo * ll_info
			 );
void		hufftab(Hcb *hcb, Huffman *hcw, int dim, int lav, int signed_cb);
void		infoinit(SR_Info *sip);
void		init();

void		init_dec(void); 

void		dec(int frame);

#if USELIB_ISOMP4
void            init_config(int extended_show);
#endif

int		initio(int argc, char *argv[], long* fileNumSample);
void		init_cc(void);
void		init_drc(void);
void		intclr(int *ip1, int cnt);
void		intcpy(int *ip1, int *ip2, int cnt);
void		intensity(MC_Info *mip, Info *info, int ch, byte *group, byte *cb_map, short *factors, int *lpflag, Float *coef[Chans]);
int		main(int argc, char *argv[]);
void*		mal1(long size);
void*		mal2(long size);
void		map_drc_channels(MC_Info *mip);
void            map_mask(Info *info, byte *group, byte *mask, byte *cb_map);
void		myexit(char *s);
int		open_output_files(MC_Info *mip);
int		pred_max_bands(void);
/* void		predict(Info* info, int profile, int *lpflag, PRED_STATUS *psp, Float *coef); */
/* void		predict_reset(Info* info, int *prstflag, PRED_STATUS **psp, int firstCh, int lastCh, int *last_rstgrp_num); */
/* void		predinit(void); */
void		print_mc_info(MC_Info *mip);
void		print_tns( TNSinfo *tns_info);
void		print_adif_header(ADIF_Header *p);
void		print_PCE(ProgConfig *p);
void		reset_drc(void);

void		reset_mc_info(MC_Info *mip);

void		restartio(
#ifdef USELIB_ISOMP4
char *resetTo
#endif
);

void		set_drc(int enable, Float hi, Float lo);
void		shortclr(short *ip1, int cnt);
int		startblock(void);
void		synt(Info *info, byte *group, byte *mask, Float *right, Float *left);
void		tns_ar_filter( Float *spec, int size, int inc, Float *lpc, int order );
void		tns_decode_coef( int order, int coef_res, short *coef, Float *a );
void		tns_decode_subblock(Float *spec, int nbands, short *sfb_top, int islong, TNSinfo *tns_info);
void int_tns_decode_subblock(int *spec, int nbands, short *sfb_top, int islong,
                             TNSinfo *tns_info);
void            tns_filter_subblock(Float *spec, int nbands, short *sfb_top, int islong,
				    TNSinfo *tns_info);
void int_tns_filter_subblock(int *spec, int nbands, short *sfb_top, int islong,
                             TNSinfo *tns_info);
int		tns_max_bands(int win);

int		tns_max_order(int islong);
void		unpack_idx(int *qp, int idx, Hcb *hcb);
void		usage(char *s);
void		writeout(Float **data, MC_Info *mip,int len);
void            pns(MC_Info *mip, Info *info, int ch, byte *group, byte *cb_map, short *factors, int *lpflag, Float *coef[Chans] );
void            predict_pns_reset(Info* info, PRED_STATUS *psp, byte *cb_map);
#ifdef BSAC
int getBSACFrameBst(unsigned char *bst, int *len);
#endif
#endif	/* _port_h_ */
