#ifdef  VERSION2
/**********************************************************************
MPEG-4 Audio VM

This software module was originally developed by
  Y.B. Thomas Kim and S.H. Park (Samsung AIT)
and edited by
  Y.B. Thomas Kim (Samsung AIT) on 1997-08-22

in the course of development of the MPEG-2 AAC/MPEG-4 Audio standard
ISO/IEC 13818-7, 14496-1,2 and 3. This software module is an
implementation of a part of one or more MPEG-2 AAC/MPEG-4 Audio tools
as specified by the MPEG-2 AAC/MPEG-4 Audio standard. ISO/IEC gives
users of the MPEG-2 AAC/MPEG-4 Audio standards free license to this
software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-2 AAC/ MPEG-4 Audio
standards. Those intending to use this software module in hardware or
software products are advised that this use may infringe existing
patents. The original developer of this software module and his/her
company, the subsequent editors and their companies, and ISO/IEC have
no liability for use of this software module or modifications thereof
in an implementation. Copyright is not released for non MPEG-2
AAC/MPEG-4 Audio conforming products. The original developer retains
full right to use the code for his/her own purpose, assign or donate
the code to a third party and to inhibit third party from using the
code for non MPEG-2 AAC/MPEG-4 Audio conforming products. This
copyright notice must be included in all copies or derivative works.

Copyright (c) 1997.


	SAMSUNG_2005-09-30 : modified buffer structure to support multi-channel output

**********************************************************************/
#include <stdio.h>

#include "sam_encode.h"

#define  MAX_LENGTH  32
#define  MINIMUM    4

#if 0
static unsigned char bs_buf[1024];      /* bit stream buffer */
static int      bs_buf_size;            /* size of buffer */
static long     bs_totbit;              /* bit counter of bit stream */
static int      bs_buf_byte_idx;        /* pointer to top byte in buffer */
static int      bs_buf_bit_idx;         /* pointer to top bit of top byte in buffer */
static int      bs_eob;                 /* end of buffer index */
static int      bs_eobs;                /* end of bit stream flag */
#endif
/* SAMSUNG_2005-09-30 */
typedef struct {
unsigned char bs_buf[2048];      /* bit stream buffer */
int      bs_buf_size;            /* size of buffer */
int      bs_buf_byte_idx;        /* pointer to top byte in buffer */
int      bs_buf_bit_idx;         /* pointer to top bit of top byte in buffer */
int      bs_eob;                 /* end of buffer index */
int      bs_eobs;                /* end of bit stream flag */
int      bs_buf_byte_idx_r;        /* pointer to top byte in buffer */
int      bs_buf_bit_idx_r;         /* pointer to top bit of top byte in buffer */
long			bs_totbit;              /* bit counter of bit stream */
}BS_ENC;

BS_ENC bs[MAX_CHANNEL_ELEMENT];
static int g_Elm;
/* ~SAMSUNG_2005-09-30 */

void sam_init_bs(void)
{
  int  i;

  /* 20060705 */
  bs[g_Elm].bs_buf_size = 2048;
  bs[g_Elm].bs_buf_byte_idx = 0;
  bs[g_Elm].bs_buf_bit_idx=8;
  bs[g_Elm].bs_totbit=0;
  bs[g_Elm].bs_eob = 0;
  bs[g_Elm].bs_eobs = 0;
  for(i = 0; i < 2048; i++)
    bs[g_Elm].bs_buf[i] = 0;
}

int putmask[9]={0x0, 0x1, 0x3, 0x7, 0xf, 0x1f, 0x3f, 0x7f, 0xff};

/*write N bits into the bit stream */
int sam_putbits2bs(int val, int N)
{
 register int j = N;
 register int k, tmp;

 if (N < 1)
  return 0;
 if (N > MAX_LENGTH) {
    printf("Cannot read or write more than %d bits[%d] at a time.\n", MAX_LENGTH, val);
    return 0;
 }

/*
 bs_totbit += N;
 while (j > 0) {
   k = (j < bs_buf_bit_idx) ? j : bs_buf_bit_idx;
   tmp = val >> (j-k);
   bs_buf[bs_buf_byte_idx] |= (tmp&putmask[k]) << (bs_buf_bit_idx-k);
   bs_buf_bit_idx -= k;
   if (!bs_buf_bit_idx) {
       bs_buf_bit_idx = 8;
       bs_buf_byte_idx++;
       if (bs_buf_byte_idx > bs_buf_size-1) {
    fprintf(stderr, "SAM: bitstream buffer overflow!\n");
     }
   }
   j -= k;
 }
*/
/* SAMSUNG_2005-09-30 */
 bs[g_Elm].bs_totbit += N;
 while (j > 0) {
   k = (j < bs[g_Elm].bs_buf_bit_idx) ? j : bs[g_Elm].bs_buf_bit_idx;
   tmp = val >> (j-k);
   bs[g_Elm].bs_buf[bs[g_Elm].bs_buf_byte_idx] |= (tmp&putmask[k]) << (bs[g_Elm].bs_buf_bit_idx-k);
   bs[g_Elm].bs_buf_bit_idx -= k;
   if (!bs[g_Elm].bs_buf_bit_idx) {
       bs[g_Elm].bs_buf_bit_idx = 8;
       bs[g_Elm].bs_buf_byte_idx++;
       if (bs[g_Elm].bs_buf_byte_idx > bs[g_Elm].bs_buf_size-1) {
    fprintf(stderr, "SAM: bitstream buffer overflow!\n");
     }
   }
   j -= k;
 }

 return N;
}

/* SAMSUNG_2005-09-30 : write N bits into the bit stream , overwrite and not advance the bits */
int sam_putbits2bs_ow(int val, int N)
{
 register int j = N;
 register int k, tmp;

 if (N < 1)
  return 0;
 if (N > MAX_LENGTH) {
    printf("Cannot read or write more than %d bits[%d] at a time.\n", MAX_LENGTH, val);
    return 0;
 }
 
 while (j > 0) {
   k = (j < bs[g_Elm].bs_buf_bit_idx) ? j : bs[g_Elm].bs_buf_bit_idx;
   tmp = val >> (j-k);
   /* 20060107 */
   bs[g_Elm].bs_buf[bs[g_Elm].bs_buf_byte_idx] &= (putmask[8-k]);
   bs[g_Elm].bs_buf[bs[g_Elm].bs_buf_byte_idx] |= (tmp&putmask[k]) << (bs[g_Elm].bs_buf_bit_idx-k);
   bs[g_Elm].bs_buf_bit_idx -= k;
   if (!bs[g_Elm].bs_buf_bit_idx) {
       bs[g_Elm].bs_buf_bit_idx = 8;
       bs[g_Elm].bs_buf_byte_idx++;
       if (bs[g_Elm].bs_buf_byte_idx > bs[g_Elm].bs_buf_size-1) {
    fprintf(stderr, "SAM: bitstream buffer overflow!\n");
     }
   }
   j -= k;
 }
 return N;
}

int sam_getWBitBufPos()
{
  /*return ((bs_buf_byte_idx * 8) + (8 - bs_buf_bit_idx));*/	
  return ((bs[g_Elm].bs_buf_byte_idx * 8) + (8 - bs[g_Elm].bs_buf_bit_idx));
}

void sam_setWBitBufPos(int pos)
{
  /*bs_buf_byte_idx = pos/8;
  bs_buf_bit_idx = 8-(pos%8);*/
	bs[g_Elm].bs_buf_byte_idx = pos/8;
  bs[g_Elm].bs_buf_bit_idx = 8-(pos%8);

}

int sam_sstell()
{
  /*return bs_totbit;*/
  return bs[g_Elm].bs_totbit;
}

void sam_frame_length_rewrite2bs(int framesize, int pos, int len)
{
/*
  int      bs_buf_byte_idx_save = bs_buf_byte_idx; 
  int      bs_buf_bit_idx_save =  bs_buf_bit_idx; 

  framesize /= 8;
  bs_buf_byte_idx = pos/8;
  bs_buf_bit_idx = 8-(pos%8);
  sam_putbits2bs(framesize, len);

  bs_buf_byte_idx = bs_buf_byte_idx_save;
  bs_buf_bit_idx =  bs_buf_bit_idx_save;*/
  int      bs_buf_byte_idx_save = bs[g_Elm].bs_buf_byte_idx; 
  int      bs_buf_bit_idx_save =  bs[g_Elm].bs_buf_bit_idx; 

  framesize /= 8;
  bs[g_Elm].bs_buf_byte_idx = pos/8;
  bs[g_Elm].bs_buf_bit_idx = 8-(pos%8);
  sam_putbits2bs_ow(framesize, len);

  bs[g_Elm].bs_buf_byte_idx = bs_buf_byte_idx_save;
  bs[g_Elm].bs_buf_bit_idx =  bs_buf_bit_idx_save;
	if(pos==0) 
		g_Elm++;

}

void sam_bsflush(HANDLE_BSBITSTREAM fixed_stream, int len)
{
  int  i;

  len /= 8;

  for(i = 0; i < len; i++)
    /*BsPutBit(fixed_stream, bs_buf[i], 8);*/
    BsPutBit(fixed_stream, bs[0].bs_buf[i], 8);
	g_Elm = 0; 
}

void sam_bsflushAll(HANDLE_BSBITSTREAM fixed_stream)
{
  int  i, j, len;
  int rbit;

 	for(i=g_Elm-1; i>=0; i--)	
	{
		len = ((bs[i].bs_totbit)/8)*8;

		len /= 8;

		rbit = bs[i].bs_totbit - len*8;
		for(j = 0; j < len; j++)
		{
			BsPutBit(fixed_stream, bs[i].bs_buf[j], 8);			
		}	
		if(rbit)
			BsPutBit(fixed_stream, (bs[i].bs_buf[len] >>(8-rbit)), rbit);
	}

	g_Elm = 0;
}

#endif  /* VERSION 2 */


#define    LEN_TNS_PRES	  1
#define    LEN_TNS_NFILTL       2
#define    LEN_TNS_NFILTS       1
#define    LEN_TNS_COEFF_RES    1
#define    LEN_TNS_LENGTHL      6
#define    LEN_TNS_LENGTHS      4
#define    LEN_TNS_ORDERL       5
#define    LEN_TNS_ORDERS       3
#define    LEN_TNS_DIRECTION    1
#define    LEN_TNS_COMPRESS     1
#define    ONLY_SHORT_WINDOW	2
#define	   MAX_SHORT_IN_LONG_BLOCK 8
#define	   DEF_TNS_RES_OFFSET 3
int sam_WriteTNSData(TNS_INFO* tns_info,    /* AACQuantInfo structure */
//		 BsBitStream* fixed_stream,  /* Pointer to bitstream */
		 int block_type,
		 int writeFlag)              /* 1 means write, 0 means count only */ 
{
  
  int bit_count = 0;
  int numWindows = 1;
  int len_tns_nfilt;
  int len_tns_length;
  int len_tns_order;
  int filtNumber;
  int resInBits;
  int bitsToTransmit;
  unsigned long unsignedIndex;
  int debugVal=3;
  int w; 
  int temp;


  TNS_INFO* tnsInfoPtr = tns_info;



//  if (writeFlag) {
    sam_putbits2bs(tnsInfoPtr->tnsDataPresent,LEN_TNS_PRES);
	if (writeFlag) {

  }
  bit_count += LEN_TNS_PRES;

  /* If TNS is not present, bail */
  if (!tnsInfoPtr->tnsDataPresent) {
    return bit_count;
  }

  /* Set window-dependent TNS parameters */
  if (block_type == ONLY_SHORT_WINDOW) {
    numWindows = MAX_SHORT_IN_LONG_BLOCK;
    len_tns_nfilt = LEN_TNS_NFILTS;
    len_tns_length = LEN_TNS_LENGTHS;
    len_tns_order = LEN_TNS_ORDERS;
  } else {
    numWindows = 1;
    len_tns_nfilt = LEN_TNS_NFILTL;
    len_tns_length = LEN_TNS_LENGTHL;
    len_tns_order = LEN_TNS_ORDERL;
  }

  /* Write TNS data */
  bit_count += numWindows * len_tns_nfilt;
  for (w=0;w<numWindows;w++) {
    TNS_WINDOW_DATA* windowDataPtr = &tnsInfoPtr->windowData[w];
    int numFilters = windowDataPtr->numFilters;
//    if (writeFlag) {
      sam_putbits2bs(numFilters,len_tns_nfilt); /* n_filt[] = 0 */
    if (writeFlag) {
    }
    if (numFilters) {
      bit_count += LEN_TNS_COEFF_RES;
      resInBits = windowDataPtr->coefResolution;
      resInBits = windowDataPtr->coefResolution;
//     if (writeFlag) {
		sam_putbits2bs(resInBits - DEF_TNS_RES_OFFSET, LEN_TNS_COEFF_RES);
     if (writeFlag) {
      }
      bit_count += numFilters * (len_tns_length+len_tns_order);
      for (filtNumber=0;filtNumber<numFilters;filtNumber++) {
	TNS_FILTER_DATA* tnsFilterPtr=&windowDataPtr->tnsFilter[filtNumber];
	int order = tnsFilterPtr->order;
//	if (writeFlag) {
	  sam_putbits2bs(tnsFilterPtr->length,len_tns_length);
	  sam_putbits2bs(order,len_tns_order);
	if (writeFlag) {
	}
	if (order) {
	  bit_count += (LEN_TNS_DIRECTION + LEN_TNS_COMPRESS);
//	  if (writeFlag) {
	    sam_putbits2bs(tnsFilterPtr->direction,LEN_TNS_DIRECTION);
	    sam_putbits2bs(tnsFilterPtr->coefCompress,LEN_TNS_COMPRESS);
	  if (writeFlag) {
	  }
	  bitsToTransmit = resInBits - tnsFilterPtr->coefCompress;
	  bit_count += order * bitsToTransmit;
//	  if (writeFlag) {
	  {
	    int i;
	    for (i=1;i<=order;i++) {
	      unsignedIndex = (unsigned long) (tnsFilterPtr->index[i])&(~(~0<<bitsToTransmit));
	      sam_putbits2bs(unsignedIndex,bitsToTransmit);
	    }
//	  }
	  }
	}
      }
    }
  }
  return bit_count;
}