#ifdef	VERSION2
/**********************************************************************
MPEG-4 Audio VM

This software module was originally developed by
  Y.B. Thomas Kim and S.H. Park (Samsung AIT)
and edited by
  Y.B. Thomas Kim (Samsung AIT) on 1997-11-06

in the course of development of the MPEG-2 AAC/MPEG-4 Audio standard
ISO/IEC 13818-7, 14496-1,2 and 3. This software module is an
implementation of a part of one or more MPEG-2 AAC/MPEG-4 Audio tools
as specified by the MPEG-2 AAC/MPEG-4 Audio standard. ISO/IEC gives
users of the MPEG-2 AAC/MPEG-4 Audio standards free license to this
software module or modifications thereof for use in hardware or
software products claiming conformance to the MPEG-2 AAC/ MPEG-4 Audio
standards. Those intending to use this software module in hardware or
software products are advised that this use may infringe existing
patents. The original developer of this software module and his/her
company, the subsequent editors and their companies, and ISO/IEC have
no liability for use of this software module or modifications thereof
in an implementation. Copyright is not released for non MPEG-2
AAC/MPEG-4 Audio conforming products. The original developer retains
full right to use the code for his/her own purpose, assign or donate
the code to a third party and to inhibit third party from using the
code for non MPEG-2 AAC/MPEG-4 Audio conforming products. This
copyright notice must be included in all copies or derivative works.

Copyright (c) 1997.

**********************************************************************/

#ifndef	_sam_enc_h_
#define	_sam_enc_h_


#include "tf_mainHandle.h"



#ifdef __cplusplus
extern "C" {
#endif


void sam_init_encode_bsac(
		int numChannel,
		int sampling_rate,
		int bit_rate,
		int block_size_samples);

int sam_encode_frame(
		int num_of_chan,
		int ch_type, /* SAMSUNG_2005-09-30 */
		WINDOW_SEQUENCE windowSequence,
		WINDOW_SHAPE	window_shape,
		int sfb_offset[],
		int nr_of_sfs,
		int num_window_groups,
		int window_group_length[],
		int	quant[][1024],
		int	scfacs[][MAX_SCFAC_BANDS],
		MSInfo      *msInfo, /* SAMSUNG_2005-09-30 */
		HANDLE_BSBITSTREAM fixed_stream,
		int i_ch,
		/*int w_flag,*/
		int avr_bits,
		int mc_ext_size, /* SAMSUNG_2005-09-30 */
		int mc_enabled, /* SAMSUNG_2005-09-30 */
		int ext_flag
		,TNS_INFO* tns_info[]
		,MS_Info * ms_info[]
		); /* SAMSUNG_2005-09-30 */


void sam_scale_bits_init_enc(
		int sampling_rate,
		int block_size);




int sam_encode_bsac(
        int target_bitrate,
				int ch_type, /* SAMSUNG_2005-09-30 : channel type */
        int windowSequence,
        int windowShape,
        int *sample[][8],
        int scalefactors[][8][MAX_SCFAC_BANDS],
        int maxSfb,
        int num_window_groups,
        int window_group_length[],
        int swb_offset[][MAX_SCFAC_BANDS],
        int top_band,
        int ModelIndex[][8][32],
        int stereo_mode,
        /*int stereo_info_buf[],*/
				int stereo_info[][MAX_SCFAC_BANDS],
        int abits,
        int i_ch,
        int nch,
				int mc_enabled, /* SAMSUNG_2005-09-30 */
				int ext_flag
	,TNS_INFO *tns_info[]
	,MS_Info *ms_info[]
	,int write_flag
				); /* SAMSUNG_2005-09-30 */


void sam_initArEncode(int arEnc_i);

void sam_storeArEncode(int arEnc_i);

void sam_setArEncode(int arEnc_i);

int sam_encode_symbol( int symbol, int armodel[]);
int sam_encode_symbol2( int symbol, int freq);

int sam_done_encoding(void);

void sam_init_bs(void);
int  sam_putbits2bs(int val, int N);
int  sam_sstell(void);
int  sam_getWBitBufPos(void);
void sam_setWBitBufPos(int);
void sam_frame_length_rewrite2bs(int framesize, int pos, int len);
void sam_bsflush(HANDLE_BSBITSTREAM fixed_steam, int len);
void sam_bsflushAll(HANDLE_BSBITSTREAM fixed_steam);/* SAMSUNG_2005-09-30 */


int sam_tf_quantize_spectrum( 	
  int quant[][NUM_COEFF],
  int scale_factor[][SFB_NUM_MAX],  
  double      *spectrum,
  double      *p_reconstructed_spectrum,
  const double energy[MAX_SCFAC_BANDS],
  const double allowed_dist[MAX_SCFAC_BANDS],
  WINDOW_SEQUENCE  windowSequence,
  WINDOW_SHAPE windowShape,
  const int   sfb_width_table[MAX_SCFAC_BANDS],
  int         sfb_offset[MAX_SCFAC_BANDS+1],   /* out: grouped sfb offsets */
  int         nr_of_sfb,
  const PnsInfo *pnsInfo,
  MSInfo      *msInfo, 
  int         available_bits,
  int         blockSizeSamples,
  int         num_window_groups,
  int   window_group_length[],
  int	i_ch
);

int sam_putbits2bs_ow(int val, int N);

#ifdef __cplusplus
}
#endif

#endif /* #ifndef	_sam_enc_h_ */
#endif	/* VERSION 2 */
int sam_WriteTNSData(TNS_INFO* tns_info,    /* AACQuantInfo structure */
//		 BsBitStream* fixed_stream,  /* Pointer to bitstream */
		int blocktype,
		 int writeFlag);              /* 1 means write, 0 means count only */ 
