/* $Id: drc.h,v 1.1 2003/11/07 13:15:11 ggr Exp $
 */
/***********

This software module was originally developed by Dolby
Laboratories and edited by Sony Corporation 
in the course of development of the MPEG-2 NBC/MPEG-4 
Audio standard ISO/IEC13818-7, 14496-1, 2 and 3. This software module is an 
implementation of a part of one or more MPEG-2 NBC/MPEG-4 Audio tools as 
specified by the MPEG-2 NBC/MPEG-4 Audio standard. ISO/IEC  gives users of the
MPEG-2NBC/MPEG-4 Audio standards free license to this software module
or modifications thereof for use in hardware or software products
claiming conformance to the MPEG-2 NBC/MPEG-4 Audio  standards. Those
intending to use this software module in hardware or software products
are advised that this use may infringe existing patents. The original
developer of this software module, the subsequent
editors and their companies, and ISO/IEC have no liability for use of
this software module or modifications thereof in an
implementation. Copyright is not released for non MPEG-2 NBC/MPEG-4
Audio conforming products. The original developer retains full right to
use the code for the developer's own purpose, assign or donate the code to a
third party and to inhibit third party from using the code for non
MPEG-2 NBC/MPEG-4 Audio conforming products. This copyright notice
must be included in all copies or derivative works. Copyright 1996.  

***********/

#ifndef DRC_H
#define DRC_H

/******************************************************************** 
/
/ filename : drc.h
/ project : MPEG-2 AAC
/ author : MCF, Matt Fellers, Dolby Laboratories, Inc.		   
/ date : July 17, 1998
/ contents/description : header file for dynamic range control 
/
/ Changes:
/ 17-July-98	  MCF  Created file
/
*******************************************************************/

typedef struct {
	short drc_num_bands;
	short prog_ref_level_present;
	short pce_tag_present;
	short excluded_chns_present;
	short drc_bands_present;
	short prog_ref_level;
	short pce_instance_tag;
	short drc_band_incr;
	short *drc_band_top;
	short *dyn_rng_sgn;
	short *dyn_rng_ctl;
	short *exclude_mask;
} DRC_VARS;

/* dynamic range */
typedef struct {
	short prog_ref_level;
	short *dyn_rng_ctl;
	short *dyn_rng_sgn;
	short dynrng_enabl;
} DRC_INTF;

typedef struct {
	short exists;
	short nbytes;
	DRC_VARS *dvars;
} DRC_PK;

void initDynRng();
int setDynRngVars( DRC_INTF *dvars_inpt, 
				   enum WINDOW_TYPE block_type[MAX_TIME_CHANNELS],
				   int nchans);
int WriteDRCArray(BsBitStream* ptrBs,	  /* Pointer to bitstream */
				 int nchans);
void ReadDynRngWords(DRC_INTF *dvars_inpt, FILE *dr_metadata);
int WriteDRCInfo  (BsBitStream *fixedStream, 
				   DRC_VARS *dvars,
				   int nchans);
int WriteExclDRCInfo(BsBitStream *fixedStream,
						DRC_VARS *dvars,
						int nchans);

#endif
