/*******************************************************************************
This software module was originally developed by

Institute for Infocomm Research and Fraunhofer IIS

and edited by

-

in the course of development of ISO/IEC 14496 for reference purposes and its
performance may not have been optimized. This software module is an
implementation of one or more tools as specified by ISO/IEC 14496. ISO/IEC gives
You a royalty-free, worldwide, non-exclusive, copyright license to copy,
distribute, and make derivative works of this software module or modifications
thereof for use in implementations of ISO/IEC 14496 in products that satisfy
conformance criteria (if any). Those intending to use this software module in
products are advised that its use may infringe existing patents. ISO/IEC have no
liability for use of this software module or modifications thereof. Copyright is
not released for products that do not conform to audiovisual and image-coding
related ITU Recommendations and/or ISO/IEC International Standards.

#ifdef NOT_PUBLISHED

Assurance that the originally developed software module can be used (1) in
ISO/IEC 14496 once ISO/IEC 14496 has been adopted; and (2) to develop ISO/IEC
14496:
Institute for Infocomm Research and Fraunhofer IIS grant ISO/IEC all
rights necessary to include the originally developed software module or
modifications thereof in ISO/IEC 14496 and to permit ISO/IEC to offer You a
royalty-free, worldwide, non-exclusive, copyright license to copy, distribute,
and make derivative works for use in implementations of ISO/IEC 14496 in
products that satisfy conformance criteria (if any), and to the extent that such
originally developed software module or portions of it are included in ISO/IEC
14496. To the extent that Institute for Infocomm Research and Fraunhofer IIS 
own patent rights that would be required to make, use, or sell the
originally developed software module or portions thereof included in ISO/IEC
14496 in a conforming product, Institute for Infocomm Research and Fraunhofer IIS 
will assure the ISO/IEC that they are willing to negotiate
licenses under reasonable and non-discriminatory terms and conditions with
applicants throughout the world. ISO/IEC gives You a free license to this
software module or modifications thereof for the sole purpose of developing
ISO/IEC 14496.

#endif

Institute for Infocomm Research and Fraunhofer IIS retain full right to
modify and use the code for their own purpose, assign or donate the code
to a third party and to inhibit third parties from using the code for products
that do not conform to MPEG-related ITU Recommendations and/or ISO/IEC
International Standards. This copyright notice must be included in all copies or
derivative works.

Copyright (c) ISO/IEC 2005.
*******************************************************************************/


#ifndef EN_LOSSLESS_H
#define EN_LOSSLESS_H
#include "aac_qc.h"
#include "int_mdct_defs.h"

#define MDCT_SCALING 45.254834
#define MDCT_SCALING_MS 32 /* compensate MS gain in MPEG decoder*/
#define MDCT_SCALING_SHORT 16
#define MDCT_SCALING_SHORT_MS 11.3137085



typedef struct LIT_LL_Info_t
{
	int type_PCM; /* PCM types, 0/1/2/3 = 16/20/24/32 bits per sample*/

	int bpc_L[MAX_OSF*MAXBANDS];
	int bpc_maxbitplane[MAX_OSF*MAXBANDS];
	int bank_type[MAX_OSF*MAXBANDS];
	double CoreScaling;

	int core_significance_signaling;
	int core_significance[MAXBANDS];

	
	int bpc_sig_maxbitplane[MAX_OSF*BLOCK_LEN_LONG];
	int bpc_interval[MAX_OSF*BLOCK_LEN_LONG];
	int significant_error[MAX_OSF*BLOCK_LEN_LONG];
	int error_spectrum[MAX_OSF*BLOCK_LEN_LONG];
	int significant_band[MAXBANDS];

	unsigned char *stream;
	long streamLen;
} LIT_LL_Info;


int lit_ll_sfg(AACQuantInfo* quantInfo,        /* ptr to quantization information */
		      int sfb_width_table[],          /* Widths of single window */
		      int *p_spectrum,           /* Spectral values, noninterleaved */
	       int osf);

void LIT_ll_perceptualEnhEnc(LIT_LL_Info * ll_Info,
			     AACQuantInfo* quantInfo ,     /* AAC quantization information */ 
			     long bit_to_use,
			     int sampling_rate,
			     int osf,
			     int short_nr_of_sfb,
			     int coreenable,
			     Ch_Info *channelInfo,
			     enum WINDOW_TYPE block_type_lossless_only,
			     int msStereoIntMDCT
			     );


int LIT_ll_errorMap(\
		    int		*p_spectrum,  /* MDCT spectrum */\
		    AACQuantInfo * quantInfo,      /* AAC quantization information */ \
		    LIT_LL_Info *ll_Info,
		    int *quant_aac,
			Ch_Info *channelInfo,
		    short msenable,
		    int osf,
		    enum WINDOW_TYPE block_type_lossless_only,
		    int* short_sfb_width,
		    int short_nr_of_sfb,
			int core_enable
		    );	

void LIT_ll_localDec(LIT_LL_Info *ll_Info,\
				AACQuantInfo *quantInfo,\
				int *quant_aac,\
				int *rec_spectrum);


void Write_ll_SCE(
		LIT_LL_Info *ll_Info,
		 AACQuantInfo* quantInfo,   /* AACQuantInfo structure */
	     BsBitStream* llStream,  /* Pointer to bitstream */
	     int writeFlag)  ;           /* 1 means write, 0 means count only */



#endif 






